"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

LibraryDefinition subclass:#stx_libtool
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libtool class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libtool.
    This library contains developer tools.
"
!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libtool/stx_libtool.st,v 1.55 2011-07-05 12:59:30 stefan Exp $'
!

extensionsVersion_SVN
    ^ 'Id:'
! !

!stx_libtool class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:goodies/xml/stx'    "XMLCoder - referenced by Tools::NewSystemBrowser>>selectorMenuFileOutXMLAs "
        #'stx:libsvn'    "SVN::RepositoryManager - referenced by NewLauncher>>updateInfo "
        #'exept:CC'    "CBrowser::Browser - referenced by FileBrowser>>hasCBrowser "
        #'exept:xml/inspector'    "XML::XMLInspector - referenced by AbstractFileBrowser>>inspectXmlFile "
        #'stx:libjava'    "Java - referenced by FileBrowser>>fileRemoveFromJavaSourcePath "
        #'stx:libjavascript'    "JavaScriptMetaclass - referenced by Tools::NewSystemBrowser>>classMenuNewJavaScriptClass "
        #'stx:libtool2'    "SnapShotImage - referenced by SystemBrowser class>>openOnSnapShotImage: "
        #'stx:libdb'    "SQL::SQLError - referenced by StoreSourceCodeManagementSettingsAppl>>tryToConnectTo: "
        #'stx:libhtml'    "HTMLDocumentView - referenced by FileBrowser>>nonBinaryFileAction: "
        #'stx:clients/Demos'    "Demos::ChickenFun - referenced by NewLauncher>>chickenFunIsRunning "
        #'stx:clients/MailTool'    "SendMailTool - referenced by DebugView>>initializeButtonsIn: "
        #'stx:clients/Tools'    "ZipTool - referenced by AbstractFileBrowser>>openZipTool "
        #'stx:goodies/communication'    "HTTPInterface - referenced by Tools::ProjectLoader>>doUpdateFromNetwork "
        #'stx:goodies/rdoit'    "RDoItServer - referenced by AbstractSettingsApplication::RDoItServerSettingsAppl>>basicSaveSettings "
        #'stx:goodies/refactoryBrowser/browser'    "MethodNameDialog - referenced by Tools::NewSystemBrowser>>renameMethod:in: "
        #'stx:goodies/refactoryBrowser/changes'    "CompositeRefactoryChange - referenced by Tools::NewSystemBrowser>>moveOrCopyMethods:toClass:moveOrCopy: "
        #'stx:goodies/refactoryBrowser/helpers'    "RBAbstractClass - referenced by Tools::NewSystemBrowser>>handlingRefactoringErrorDo: "
        #'stx:goodies/refactoryBrowser/lint'    "ParseTreeLintRule - referenced by Tools::ClassChecker>>guardingClause "
        #'stx:goodies/refactoryBrowser/refactoring'    "PushDownClassVariableRefactoring - referenced by Tools::NewSystemBrowser>>codeMenuPushDownClassVariable:inClass: "
        #'stx:goodies/sif'    "SmalltalkInterchangeFileManager - referenced by Tools::NewSystemBrowser>>projectMenuFileOutAsWithFormat: "
        #'stx:goodies/simpleServices'    "WindowMigrationServer - referenced by AbstractSettingsApplication::MiscCommunicationSettingsAppl>>hasUnsavedChanges "
        #'stx:goodies/soap'    "SOAP::SoapHttpModule - referenced by AbstractLauncherApplication::LauncherDialogs class>>communicationsSettings "
        #'stx:goodies/soap/examples'    "SOAP::BabelFishClient - referenced by WorkspaceApplication>>babelFishTranslate: "
        #'stx:goodies/sunit'    "TestCase - referenced by Tools::NewSystemBrowser>>browseMenuTestCaseClasses "
        #'stx:goodies/webServer'    "HTTPService - referenced by SmalltalkCodeGeneratorTool>>createDocumentationMethodFor: "
        #'stx:goodies/webServer/ui'    "HTTPServerSettingsAppl - referenced by AbstractSettingsApplication::HTTPStartServerSettingsApplication>>hasCreatedServer "
        #'stx:goodies/xml/vw'    "XML::XMLParser - referenced by FileApplicationNoteBook::XMLViewApplication>>updateXMLTree "
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/refactoryBrowser/parser'    "RBProgramNodeVisitor - superclass of Tools::BreakpointBrowser::MessageArgumentExtractor "
        #'stx:libbasic'    "Object - superclass of VersionDiffBrowser::ClassChangeSet "
        #'stx:libbasic2'    "List - superclass of AbstractFileBrowser::DirectoryHistory "
        #'stx:libbasic3'    "MessageTally - superclass of Tools::Profiler "
        #'stx:libboss'    "BinaryOutputManager - referenced by Tools::Profiler>>storeStatisticsOn: "
        #'stx:libcomp'    "Parser - superclass of SyntaxHighlighter2 "
        #'stx:libui'    "MenuComponentSpec - superclass of EditFieldWithCompletionSpec "
        #'stx:libview'    "SimpleView - superclass of InspectorView "
        #'stx:libview2'    "SimpleDialog - superclass of FileDialog "
        #'stx:libwidg'    "DialogBox - superclass of AboutBox "
        #'stx:libwidg2'    "SelectionInListModelView - superclass of Tools::CodeCompletionMenu "
        #'stx:libwidg3'    "ClockView - referenced by WorkspaceApplication>>addStopWatch "
    )
! !

!stx_libtool class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBTOOL_BASE
LIB_BASE=$(LIBTOOL_BASE)
'
! !

!stx_libtool class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AboutBox
        AbstractFileApplicationNoteBookComponent
        AbstractFileBrowser
        AbstractLauncherApplication
        (AbstractRevisionItem autoload)
        AbstractSettingsApplication
        (AbstractVersionDiffBrowserItem autoload)
        (ApplicationBuilder autoload)
        Bookmark
        BookmarkBar
        BookmarkEditor
        BookmarkList
        BookmarkListEditor
        BookmarkVisitor
        BookmarksEditDialog
        BrowserView
        (ChangeSetBrowser autoload)
        ChangesBrowser
        (ClassInspectorView autoload)
        (ClassItem autoload)
        (ClassItemRoot autoload)
        (ClassItemRootForRevision autoload)
        (ClassNameItem autoload)
        (ClassRevisionTree autoload)
        (ClassVariablesInspectorView autoload)
        CodeGenerator
        (CodeGeneratorTests autoload)
        CodeGeneratorTool
        (ColorInspectorView autoload)
        DebugView
        Diff
        (Diff3TextView autoload)
        DiffListUtility
        DiffTextView
        (EWorldIconLibrary autoload)
        EditFieldWithCompletion
        EditFieldWithCompletionSpec
        (EventMonitor autoload)
        (ExpandableRevisionItem autoload)
        FileBrowser
        FileBrowserV2PanelView
        (FileBrowserV2SettingsDialog autoload)
        (FileBrowserV2Tests autoload)
        FileBrowserV2UISpecifications
        FileDialog
        (FileDialogV2 autoload)
        FileOperation
        FilenameEditFieldV2
        (HierarchicalClassRevisionList autoload)
        (HierarchicalVersionDiffBrowser autoload)
        InspectorView
        (Launcher autoload)
        (LibraryBuilder autoload)
        MemoryMonitor
        MemoryMonitorView
        (MemoryUsageView autoload)
        MultiViewToolApplication
        (NewChangesBrowser autoload)
        (OldLauncher autoload)
        (ProcessMonitor autoload)
        ProcessMonitorV2
        (ProjectView autoload)
        (RCSConflictEditTextView autoload)
        (SemaphoreMonitor autoload)
        SettingsDialog
        (SmalltalkInspectorView autoload)
        (SourceRevisionItem autoload)
        SyntaxElement
        SyntaxHighlighter2
        SystemBrowser
        (SystemStatusMonitor autoload)
        (TerminalApplication autoload)
        (TextDiffTests autoload)
        #'Tools::AbstractTestRunner'
        #'Tools::BackgroundJob'
        #'Tools::BreakpointBrowser'
        #'Tools::Browslet'
        #'Tools::BrowsletCanvas'
        #'Tools::CachedTags'
        #'Tools::CheckinInfoDialog'
        #'Tools::ClassChecker'
        #'Tools::ClassSorter'
        #'Tools::CodeCompletionMenu'
        #'Tools::CodeCritics'
        #'Tools::CodeView2'
        (#'Tools::CodeView2DemoApp' autoload)
        #'Tools::CodeViewService'
        (#'Tools::CompilerWarningToDoListEntry' autoload)
        #'Tools::DiffCodeView2'
        (#'Tools::DiffCodeView2DemoApp' autoload)
        #'Tools::HierarchicalChangesetDialog'
        #'Tools::InlineMessageDialog'
        #'Tools::Inspector2'
        #'Tools::Inspector2Tab'
        #'Tools::LintRuleDetail'
        #'Tools::LintRuleSelectionDialog'
        #'Tools::MethodCategoryCache'
        #'Tools::MethodRewriter'
        #'Tools::NavigationHistory'
        (#'Tools::NavigationHistoryTests' autoload)
        #'Tools::NavigationState'
        #'Tools::NavigatorModel'
        #'Tools::NewClassWizardDialog'
        #'Tools::NewSystemBrowserCodeView'
        #'Tools::Profiler'
        #'Tools::ProfilerInfoBuilder'
        #'Tools::ProfilerInfoItem'
        #'Tools::ProjectLoader'
        #'Tools::SearchDialog'
        #'Tools::SmalltalkDiffTool'
        (#'Tools::SmalltalkMergeTool' autoload)
        #'Tools::SpecialCodeView'
        #'Tools::StringSearchTool'
        #'Tools::Tag'
        #'Tools::TagList'
        #'Tools::TagsBrowser'
        (#'Tools::ToDoList' autoload)
        (#'Tools::ToDoListBrowser' autoload)
        (#'Tools::ToDoListEntry' autoload)
        (#'Tools::ToDoNotification' autoload)
        #'Tools::WebBrowserPage'
        VersionDiffBrowser
        (VersionRevisionItem autoload)
        ViewWithAcceptAndCancelBar
        Win32FileDialog
        #'stx_libtool'
        AbstractDirectoryBrowser
        AbstractSourceCodeManagementSettingsAppl
        BookmarkMenuBuilder
        ContextInspectorView
        DictionaryInspectorView
        DiffCodeView
        FileApplicationNoteBook
        FileBrowserV2
        FileBrowserV2SettingsAppl
        FileDialogWithPreview
        FindFileApplication
        ImageInspectorView
        NewLauncher
        OrderedCollectionInspectorView
        SetInspectorView
        SmalltalkCodeGeneratorTool
        #'Tools::BackgroundQueueProcessingJob'
        #'Tools::BreakpointService'
        #'Tools::BrowserList'
        #'Tools::CodeCompletionService'
        #'Tools::CodeHighlightingService'
        #'Tools::CodeNavigationService'
        #'Tools::NavigatorCanvas'
        #'Tools::NewSystemBrowser'
        #'Tools::OrganizerCanvas'
        #'Tools::SendersBrowslet'
        #'Tools::StringSearchToolForTextView'
        #'Tools::TestRunnerEmbedded'
        #'Tools::VisualProfilerCanvas'
        WorkspaceApplication
        BookmarkAddMenuBuilder
        BookmarkToolbarMenuBuilder
        CVSSourceCodeManagementSettingsAppl
        DirectoryContentsBrowser
        DirectoryTreeBrowser
        PerforceSourceCodeManagementSettingsAppl
        StoreSourceCodeManagementSettingsAppl
        #'Tools::ChangeList'
        #'Tools::ClassCategoryList'
        #'Tools::ClassGeneratorList'
        #'Tools::ClassList'
        #'Tools::LintRuleList'
        #'Tools::MethodCategoryList'
        #'Tools::MethodList'
        #'Tools::NamespaceList'
        #'Tools::ProjectList'
        #'Tools::VariableList'
        #'Tools::FullMethodCategoryList'
        #'Tools::HierarchicalChangeList'
        #'Tools::HierarchicalClassCategoryList'
        #'Tools::HierarchicalClassList'
        #'Tools::HierarchicalLintRuleList'
        #'Tools::HierarchicalProjectList'
        #'Tools::ImplementingClassList'
        #'Tools::ImplementingMethodList'
        #'Tools::NamespaceFilter'
        #'Tools::TestRunner2'
        #'Tools::HierarchicalPackageFilterList'
        #'Tools::InheritanceClassList'
        #'Tools::ChangeSetBrowser2'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteArray inspectorExtraAttributes
        Character inspectorExtraAttributes
        CharacterArray inspectorExtraAttributes
        Collection inspectorExtraAttributes
        Color inspectorClass
        Color inspectorExtraAttributes
        Dictionary inspectorClass
        ExecutableFunction printStringForBrowserWithSelector:
        Form inspectorClass
        Image inspectorClass
        Integer inspectorExtraAttributes
        Method inspectorExtraAttributes
        Method printStringForBrowserWithSelector:inClass:
        Method selectorPrintStringInBrowserFor:
        Method selectorPrintStringInBrowserFor:class:
        MethodDictionary inspectorClass
        Object inspectorExtraAttributes
        OrderedCollection inspectorClass
        RunArray inspectorClass
        Set inspectorClass
        Text inspectorExtraAttributes
        'NameSpace class' inspectorClass
        'Smalltalk class' inspectorClass
        Breakpoint icon
        Change flattenOnto:
        Change flattenedChanges
        Change removed
        Change removed:
        ChangeSet condenseChangesForRemoved
        ChangeSet flattenOnto:
        ChangeSet flattenedChanges
        ChangeSet inspector2TabBrowser
        CharacterArray inspector2TabText
        ClassDescription iconInBrowserForVariableNamed:
        CompositeChange condenseChangesForRemoved
        CompositeChange flattenOnto:
        CompositeChange removed
        CompositeChange removed:
        Date inspectorExtraAttributes
        EditTextView absoluteXOfPosition:
        EditTextView absoluteYOfCursor
        EditTextView xOfPosition:
        EditTextView yOfCursor
        EditTextView yOfPosition:
        MenuView shortKeys
        Object asTestCase
        Object inspect
        Object inspector2TabCommon
        Object isTestCaseLike
        Object newInspector2Tab
        PopUpMenu asMenu
        ProfileTree method
        ProfileTree package
        SelectionInListModelView textStartLeft
        SelectionInListModelView textStartLeft:
        SimpleView isCodeView2
        StringCollection inspector2TabText
        Symbol formattedCode
        Text inspector2TabText
        Timestamp inspectorExtraAttributes
        UserPreferences alwaysOpenNewTabWhenCtrlClick
        UserPreferences alwaysOpenNewTabWhenCtrlClick:
        UserPreferences showBookmarkBar
        UserPreferences showBookmarkBar:
        UserPreferences showEmbeddedTestRunnerInBrowser
        UserPreferences showEmbeddedTestRunnerInBrowser:
        UserPreferences showMethodTemplate
        UserPreferences showMethodTemplate:
        UserPreferences useCodeView2InTools
        UserPreferences useCodeView2InTools:
        UserPreferences webBrowserLikeLayout
        UserPreferences webBrowserLikeLayout:
        'AbstractSyntaxHighlighter class' formatExpression:in:elementsInto:
        'AbstractSyntaxHighlighter class' formatMethod:in:using:elementsInto:
        'DoWhatIMeanSupport class' askUserForCompletion:for:at:from:
        'DoWhatIMeanSupport class' codeCompletionForLiteralSymbol:inClass:codeView:
        'DoWhatIMeanSupport class' codeCompletionForMessage:inClass:codeView:
        'DoWhatIMeanSupport class' codeCompletionForMethod:inClass:codeView:
        'DoWhatIMeanSupport class' methodProtocolCompletion:inEnvironment:
        'DoWhatIMeanSupport class' #'old_askUserForCompletion:for:from:'
        'GenericToolbarIconLibrary class' bookmarks22x22
        'GenericToolbarIconLibrary class' #'brkp_obj'
        'GenericToolbarIconLibrary class' #'brkpd_obj'
        'GenericToolbarIconLibrary class' bug16x16Icon
        'GenericToolbarIconLibrary class' bug24x24Icon
        'GenericToolbarIconLibrary class' bug32x32Icon
        'GenericToolbarIconLibrary class' lint16x16Icon
        'GenericToolbarIconLibrary class' lint24x24Icon
        'GenericToolbarIconLibrary class' lint32x32Icon
    )
! !

!stx_libtool class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Tools'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:56:18 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_libtool class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/stx_libtool.st,v 1.55 2011-07-05 12:59:30 stefan Exp $'
! !
